diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 34ca6d4ac2..d424450e7b 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -21,6 +21,7 @@
 #include "access/sysattr.h"
 #include "catalog/pg_class.h"
 #include "foreign/fdwapi.h"
+#include "jit/jit.h"
 #include "miscadmin.h"
 #include "nodes/extensible.h"
 #include "nodes/makefuncs.h"
@@ -71,96 +72,142 @@
 #define CP_IGNORE_TLIST		0x0008	/* caller will replace tlist */
 
 
-static Plan *create_plan_recurse(PlannerInfo *root, Path *best_path,
-								 int flags);
-static Plan *create_scan_plan(PlannerInfo *root, Path *best_path,
-							  int flags);
+static Plan *create_plan_recurse(CreatePlanContext *context, PlannerInfo *root,
+								 Path *best_path, int flags);
+static void plan_consider_jit(CreatePlanContext *context, PlannerInfo *root,
+							  Plan *plan);
+static Plan *create_scan_plan(CreatePlanContext *context, PlannerInfo *root,
+							  Path *best_path, int flags);
 static List *build_path_tlist(PlannerInfo *root, Path *path);
 static bool use_physical_tlist(PlannerInfo *root, Path *path, int flags);
 static List *get_gating_quals(PlannerInfo *root, List *quals);
-static Plan *create_gating_plan(PlannerInfo *root, Path *path, Plan *plan,
-								List *gating_quals);
-static Plan *create_join_plan(PlannerInfo *root, JoinPath *best_path);
+static Plan *create_gating_plan(CreatePlanContext *context, PlannerInfo *root,
+								Path *path, Plan *plan, List *gating_quals);
+static Plan *create_join_plan(CreatePlanContext *context, PlannerInfo *root,
+							  JoinPath *best_path);
 static bool mark_async_capable_plan(Plan *plan, Path *path);
-static Plan *create_append_plan(PlannerInfo *root, AppendPath *best_path,
-								int flags);
-static Plan *create_merge_append_plan(PlannerInfo *root, MergeAppendPath *best_path,
+static Plan *create_append_plan(CreatePlanContext *context, PlannerInfo *root,
+								AppendPath *best_path, int flags);
+static Plan *create_merge_append_plan(CreatePlanContext *context,
+									  PlannerInfo *root,
+									  MergeAppendPath *best_path,
 									  int flags);
-static Result *create_group_result_plan(PlannerInfo *root,
+static Result *create_group_result_plan(CreatePlanContext *context,
+										PlannerInfo *root,
 										GroupResultPath *best_path);
-static ProjectSet *create_project_set_plan(PlannerInfo *root, ProjectSetPath *best_path);
-static Material *create_material_plan(PlannerInfo *root, MaterialPath *best_path,
-									  int flags);
-static Memoize *create_memoize_plan(PlannerInfo *root, MemoizePath *best_path,
-									int flags);
-static Plan *create_unique_plan(PlannerInfo *root, UniquePath *best_path,
-								int flags);
-static Gather *create_gather_plan(PlannerInfo *root, GatherPath *best_path);
-static Plan *create_projection_plan(PlannerInfo *root,
+static ProjectSet *create_project_set_plan(CreatePlanContext *context,
+										   PlannerInfo *root,
+										   ProjectSetPath *best_path);
+static Material *create_material_plan(CreatePlanContext *context, PlannerInfo *root,
+									  MaterialPath *best_path, int flags);
+static Memoize *create_memoize_plan(CreatePlanContext *context, PlannerInfo *root,
+									MemoizePath *best_path, int flags);
+static Plan *create_unique_plan(CreatePlanContext *context, PlannerInfo *root,
+								UniquePath *best_path, int flags);
+static Gather *create_gather_plan(CreatePlanContext *context, PlannerInfo *root,
+								  GatherPath *best_path);
+static Plan *create_projection_plan(CreatePlanContext *context,
+									PlannerInfo *root,
 									ProjectionPath *best_path,
 									int flags);
-static Plan *inject_projection_plan(Plan *subplan, List *tlist, bool parallel_safe);
-static Sort *create_sort_plan(PlannerInfo *root, SortPath *best_path, int flags);
-static IncrementalSort *create_incrementalsort_plan(PlannerInfo *root,
-													IncrementalSortPath *best_path, int flags);
-static Group *create_group_plan(PlannerInfo *root, GroupPath *best_path);
-static Unique *create_upper_unique_plan(PlannerInfo *root, UpperUniquePath *best_path,
+static Plan *inject_projection_plan(CreatePlanContext *context, Plan *subplan,
+									List *tlist, bool parallel_safe);
+static Sort *create_sort_plan(CreatePlanContext *context, PlannerInfo *root,
+							  SortPath *best_path, int flags);
+static IncrementalSort *create_incrementalsort_plan(CreatePlanContext *context,
+													PlannerInfo *root,
+													IncrementalSortPath *best_path,
+													int flags);
+static Group *create_group_plan(CreatePlanContext *context, PlannerInfo *root,
+								GroupPath *best_path);
+static Unique *create_upper_unique_plan(CreatePlanContext *context,
+										PlannerInfo *root,
+										UpperUniquePath *best_path,
 										int flags);
-static Agg *create_agg_plan(PlannerInfo *root, AggPath *best_path);
-static Plan *create_groupingsets_plan(PlannerInfo *root, GroupingSetsPath *best_path);
-static Result *create_minmaxagg_plan(PlannerInfo *root, MinMaxAggPath *best_path);
-static WindowAgg *create_windowagg_plan(PlannerInfo *root, WindowAggPath *best_path);
-static SetOp *create_setop_plan(PlannerInfo *root, SetOpPath *best_path,
-								int flags);
-static RecursiveUnion *create_recursiveunion_plan(PlannerInfo *root, RecursiveUnionPath *best_path);
-static LockRows *create_lockrows_plan(PlannerInfo *root, LockRowsPath *best_path,
-									  int flags);
-static ModifyTable *create_modifytable_plan(PlannerInfo *root, ModifyTablePath *best_path);
-static Limit *create_limit_plan(PlannerInfo *root, LimitPath *best_path,
-								int flags);
-static SeqScan *create_seqscan_plan(PlannerInfo *root, Path *best_path,
-									List *tlist, List *scan_clauses);
-static SampleScan *create_samplescan_plan(PlannerInfo *root, Path *best_path,
+static Agg *create_agg_plan(CreatePlanContext *context, PlannerInfo *root,
+							AggPath *best_path);
+static Plan *create_groupingsets_plan(CreatePlanContext *context, PlannerInfo *root,
+									  GroupingSetsPath *best_path);
+static Result *create_minmaxagg_plan(CreatePlanContext *context, PlannerInfo *root,
+									 MinMaxAggPath *best_path);
+static WindowAgg *create_windowagg_plan(CreatePlanContext *context, PlannerInfo *root,
+										WindowAggPath *best_path);
+static SetOp *create_setop_plan(CreatePlanContext *context, PlannerInfo *root,
+								SetOpPath *best_path, int flags);
+static RecursiveUnion *create_recursiveunion_plan(CreatePlanContext *context,
+												  PlannerInfo *root,
+												  RecursiveUnionPath *best_path);
+static LockRows *create_lockrows_plan(CreatePlanContext *context, PlannerInfo *root,
+									  LockRowsPath *best_path, int flags);
+static ModifyTable *create_modifytable_plan(CreatePlanContext *context,
+											PlannerInfo *root,
+											ModifyTablePath *best_path);
+static Limit *create_limit_plan(CreatePlanContext *context, PlannerInfo *root,
+								LimitPath *best_path, int flags);
+static SeqScan *create_seqscan_plan(CreatePlanContext *context, PlannerInfo *root,
+									Path *best_path, List *tlist, List *scan_clauses);
+static SampleScan *create_samplescan_plan(CreatePlanContext *context,
+										  PlannerInfo *root, Path *best_path,
 										  List *tlist, List *scan_clauses);
-static Scan *create_indexscan_plan(PlannerInfo *root, IndexPath *best_path,
-								   List *tlist, List *scan_clauses, bool indexonly);
-static BitmapHeapScan *create_bitmap_scan_plan(PlannerInfo *root,
+static Scan *create_indexscan_plan(CreatePlanContext *context, PlannerInfo *root,
+								   IndexPath *best_path, List *tlist,
+								   List *scan_clauses, bool indexonly);
+static BitmapHeapScan *create_bitmap_scan_plan(CreatePlanContext *context,
+											   PlannerInfo *root,
 											   BitmapHeapPath *best_path,
 											   List *tlist, List *scan_clauses);
-static Plan *create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
-								   List **qual, List **indexqual, List **indexECs);
+static Plan *create_bitmap_subplan(CreatePlanContext *context, PlannerInfo *root,
+								   Path *bitmapqual, List **qual, List **indexqual,
+								   List **indexECs);
 static void bitmap_subplan_mark_shared(Plan *plan);
-static TidScan *create_tidscan_plan(PlannerInfo *root, TidPath *best_path,
-									List *tlist, List *scan_clauses);
-static TidRangeScan *create_tidrangescan_plan(PlannerInfo *root,
+static TidScan *create_tidscan_plan(CreatePlanContext *context, PlannerInfo *root,
+									TidPath *best_path, List *tlist,
+									List *scan_clauses);
+static TidRangeScan *create_tidrangescan_plan(CreatePlanContext *context,
+											  PlannerInfo *root,
 											  TidRangePath *best_path,
 											  List *tlist,
 											  List *scan_clauses);
-static SubqueryScan *create_subqueryscan_plan(PlannerInfo *root,
+static SubqueryScan *create_subqueryscan_plan(CreatePlanContext *context,
+											  PlannerInfo *root,
 											  SubqueryScanPath *best_path,
 											  List *tlist, List *scan_clauses);
-static FunctionScan *create_functionscan_plan(PlannerInfo *root, Path *best_path,
+static FunctionScan *create_functionscan_plan(CreatePlanContext *context,
+											  PlannerInfo *root, Path *best_path,
 											  List *tlist, List *scan_clauses);
-static ValuesScan *create_valuesscan_plan(PlannerInfo *root, Path *best_path,
+static ValuesScan *create_valuesscan_plan(CreatePlanContext *context, 
+										  PlannerInfo *root, Path *best_path,
 										  List *tlist, List *scan_clauses);
-static TableFuncScan *create_tablefuncscan_plan(PlannerInfo *root, Path *best_path,
+static TableFuncScan *create_tablefuncscan_plan(CreatePlanContext *context,
+												PlannerInfo *root, Path *best_path,
 												List *tlist, List *scan_clauses);
-static CteScan *create_ctescan_plan(PlannerInfo *root, Path *best_path,
-									List *tlist, List *scan_clauses);
-static NamedTuplestoreScan *create_namedtuplestorescan_plan(PlannerInfo *root,
-															Path *best_path, List *tlist, List *scan_clauses);
-static Result *create_resultscan_plan(PlannerInfo *root, Path *best_path,
+static CteScan *create_ctescan_plan(CreatePlanContext *context, PlannerInfo *root,
+									Path *best_path, List *tlist, List *scan_clauses);
+static NamedTuplestoreScan *create_namedtuplestorescan_plan(CreatePlanContext *context,
+															PlannerInfo *root,
+															Path *best_path,
+															List *tlist,
+															List *scan_clauses);
+static Result *create_resultscan_plan(CreatePlanContext *context,
+									  PlannerInfo *root, Path *best_path,
 									  List *tlist, List *scan_clauses);
-static WorkTableScan *create_worktablescan_plan(PlannerInfo *root, Path *best_path,
+static WorkTableScan *create_worktablescan_plan(CreatePlanContext *context,
+												PlannerInfo *root, Path *best_path,
 												List *tlist, List *scan_clauses);
-static ForeignScan *create_foreignscan_plan(PlannerInfo *root, ForeignPath *best_path,
+static ForeignScan *create_foreignscan_plan(CreatePlanContext *context,
+											PlannerInfo *root, ForeignPath *best_path,
 											List *tlist, List *scan_clauses);
-static CustomScan *create_customscan_plan(PlannerInfo *root,
+static CustomScan *create_customscan_plan(CreatePlanContext *context,
+										  PlannerInfo *root,
 										  CustomPath *best_path,
 										  List *tlist, List *scan_clauses);
-static NestLoop *create_nestloop_plan(PlannerInfo *root, NestPath *best_path);
-static MergeJoin *create_mergejoin_plan(PlannerInfo *root, MergePath *best_path);
-static HashJoin *create_hashjoin_plan(PlannerInfo *root, HashPath *best_path);
+static NestLoop *create_nestloop_plan(CreatePlanContext *context,
+									  PlannerInfo *root,
+									  NestPath *best_path);
+static MergeJoin *create_mergejoin_plan(CreatePlanContext *context,
+										PlannerInfo *root, MergePath *best_path);
+static HashJoin *create_hashjoin_plan(CreatePlanContext *context,
+									  PlannerInfo *root, HashPath *best_path);
 static Node *replace_nestloop_params(PlannerInfo *root, Node *expr);
 static Node *replace_nestloop_params_mutator(Node *node, PlannerInfo *root);
 static void fix_indexqual_references(PlannerInfo *root, IndexPath *index_path,
@@ -260,7 +307,8 @@ static IncrementalSort *make_incrementalsort(Plan *lefttree,
 											 int numCols, int nPresortedCols,
 											 AttrNumber *sortColIdx, Oid *sortOperators,
 											 Oid *collations, bool *nullsFirst);
-static Plan *prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
+static Plan *prepare_sort_from_pathkeys(CreatePlanContext *context,
+										Plan *lefttree, List *pathkeys,
 										Relids relids,
 										const AttrNumber *reqColIdx,
 										bool adjust_tlist_in_place,
@@ -269,9 +317,11 @@ static Plan *prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
 										Oid **p_sortOperators,
 										Oid **p_collations,
 										bool **p_nullsFirst);
-static Sort *make_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
+static Sort *make_sort_from_pathkeys(CreatePlanContext *context,
+									 Plan *lefttree, List *pathkeys,
 									 Relids relids);
-static IncrementalSort *make_incrementalsort_from_pathkeys(Plan *lefttree,
+static IncrementalSort *make_incrementalsort_from_pathkeys(CreatePlanContext *context,
+														   Plan *lefttree,
 														   List *pathkeys, Relids relids, int nPresortedCols);
 static Sort *make_sort_from_groupcols(List *groupcls,
 									  AttrNumber *grpColIdx,
@@ -312,8 +362,10 @@ static ModifyTable *make_modifytable(PlannerInfo *root, Plan *subplan,
 									 List *withCheckOptionLists, List *returningLists,
 									 List *rowMarks, OnConflictExpr *onconflict,
 									 List *mergeActionLists, int epqParam);
-static GatherMerge *create_gather_merge_plan(PlannerInfo *root,
+static GatherMerge *create_gather_merge_plan(CreatePlanContext *context,
+											 PlannerInfo *root,
 											 GatherMergePath *best_path);
+static void copy_create_plan_context(CreatePlanContext *dest, CreatePlanContext *src);
 
 
 /*
@@ -332,7 +384,7 @@ static GatherMerge *create_gather_merge_plan(PlannerInfo *root,
  *	  Returns a Plan tree.
  */
 Plan *
-create_plan(PlannerInfo *root, Path *best_path)
+create_plan(CreatePlanContext *context, PlannerInfo *root, Path *best_path)
 {
 	Plan	   *plan;
 
@@ -344,7 +396,7 @@ create_plan(PlannerInfo *root, Path *best_path)
 	root->curOuterParams = NIL;
 
 	/* Recursively process the path tree, demanding the correct tlist result */
-	plan = create_plan_recurse(root, best_path, CP_EXACT_TLIST);
+	plan = create_plan_recurse(context, root, best_path, CP_EXACT_TLIST);
 
 	/*
 	 * Make sure the topmost plan node's targetlist exposes the original
@@ -383,7 +435,8 @@ create_plan(PlannerInfo *root, Path *best_path)
  *	  Recursive guts of create_plan().
  */
 static Plan *
-create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
+create_plan_recurse(CreatePlanContext *context, PlannerInfo *root,
+					Path *best_path, int flags)
 {
 	Plan	   *plan;
 
@@ -408,135 +461,159 @@ create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
 		case T_NamedTuplestoreScan:
 		case T_ForeignScan:
 		case T_CustomScan:
-			plan = create_scan_plan(root, best_path, flags);
+			plan = create_scan_plan(context, root, best_path, flags);
 			break;
 		case T_HashJoin:
 		case T_MergeJoin:
 		case T_NestLoop:
-			plan = create_join_plan(root,
+			plan = create_join_plan(context,
+									root,
 									(JoinPath *) best_path);
 			break;
 		case T_Append:
-			plan = create_append_plan(root,
+			plan = create_append_plan(context,
+									  root,
 									  (AppendPath *) best_path,
 									  flags);
 			break;
 		case T_MergeAppend:
-			plan = create_merge_append_plan(root,
+			plan = create_merge_append_plan(context,
+											root,
 											(MergeAppendPath *) best_path,
 											flags);
 			break;
 		case T_Result:
 			if (IsA(best_path, ProjectionPath))
 			{
-				plan = create_projection_plan(root,
+				plan = create_projection_plan(context,
+											  root,
 											  (ProjectionPath *) best_path,
 											  flags);
 			}
 			else if (IsA(best_path, MinMaxAggPath))
 			{
-				plan = (Plan *) create_minmaxagg_plan(root,
+				plan = (Plan *) create_minmaxagg_plan(context,
+													  root,
 													  (MinMaxAggPath *) best_path);
 			}
 			else if (IsA(best_path, GroupResultPath))
 			{
-				plan = (Plan *) create_group_result_plan(root,
+				plan = (Plan *) create_group_result_plan(context,
+														 root,
 														 (GroupResultPath *) best_path);
 			}
 			else
 			{
 				/* Simple RTE_RESULT base relation */
 				Assert(IsA(best_path, Path));
-				plan = create_scan_plan(root, best_path, flags);
+				plan = create_scan_plan(context, root, best_path, flags);
 			}
 			break;
 		case T_ProjectSet:
-			plan = (Plan *) create_project_set_plan(root,
+			plan = (Plan *) create_project_set_plan(context,
+													root,
 													(ProjectSetPath *) best_path);
 			break;
 		case T_Material:
-			plan = (Plan *) create_material_plan(root,
+			plan = (Plan *) create_material_plan(context,
+												 root,
 												 (MaterialPath *) best_path,
 												 flags);
 			break;
 		case T_Memoize:
-			plan = (Plan *) create_memoize_plan(root,
+			plan = (Plan *) create_memoize_plan(context,
+												root,
 												(MemoizePath *) best_path,
 												flags);
 			break;
 		case T_Unique:
 			if (IsA(best_path, UpperUniquePath))
 			{
-				plan = (Plan *) create_upper_unique_plan(root,
+				plan = (Plan *) create_upper_unique_plan(context,
+														 root,
 														 (UpperUniquePath *) best_path,
 														 flags);
 			}
 			else
 			{
 				Assert(IsA(best_path, UniquePath));
-				plan = create_unique_plan(root,
+				plan = create_unique_plan(context,
+										  root,
 										  (UniquePath *) best_path,
 										  flags);
 			}
 			break;
 		case T_Gather:
-			plan = (Plan *) create_gather_plan(root,
+			plan = (Plan *) create_gather_plan(context,
+											   root,
 											   (GatherPath *) best_path);
 			break;
 		case T_Sort:
-			plan = (Plan *) create_sort_plan(root,
+			plan = (Plan *) create_sort_plan(context,
+											 root,
 											 (SortPath *) best_path,
 											 flags);
 			break;
 		case T_IncrementalSort:
-			plan = (Plan *) create_incrementalsort_plan(root,
+			plan = (Plan *) create_incrementalsort_plan(context,
+														root,
 														(IncrementalSortPath *) best_path,
 														flags);
 			break;
 		case T_Group:
-			plan = (Plan *) create_group_plan(root,
+			plan = (Plan *) create_group_plan(context,
+											  root,
 											  (GroupPath *) best_path);
 			break;
 		case T_Agg:
 			if (IsA(best_path, GroupingSetsPath))
-				plan = create_groupingsets_plan(root,
+				plan = create_groupingsets_plan(context,
+												root,
 												(GroupingSetsPath *) best_path);
 			else
 			{
 				Assert(IsA(best_path, AggPath));
-				plan = (Plan *) create_agg_plan(root,
+				plan = (Plan *) create_agg_plan(context,
+												root,
 												(AggPath *) best_path);
 			}
 			break;
 		case T_WindowAgg:
-			plan = (Plan *) create_windowagg_plan(root,
+			plan = (Plan *) create_windowagg_plan(context,
+												  root,
 												  (WindowAggPath *) best_path);
 			break;
 		case T_SetOp:
-			plan = (Plan *) create_setop_plan(root,
+			plan = (Plan *) create_setop_plan(context,
+											  root,
 											  (SetOpPath *) best_path,
 											  flags);
 			break;
 		case T_RecursiveUnion:
-			plan = (Plan *) create_recursiveunion_plan(root,
+			plan = (Plan *) create_recursiveunion_plan(context,
+													   root,
 													   (RecursiveUnionPath *) best_path);
 			break;
 		case T_LockRows:
-			plan = (Plan *) create_lockrows_plan(root,
+			plan = (Plan *) create_lockrows_plan(context,
+												 root,
 												 (LockRowsPath *) best_path,
 												 flags);
 			break;
 		case T_ModifyTable:
-			plan = (Plan *) create_modifytable_plan(root,
+			plan = (Plan *) create_modifytable_plan(context,
+													root,
 													(ModifyTablePath *) best_path);
 			break;
 		case T_Limit:
-			plan = (Plan *) create_limit_plan(root,
+			plan = (Plan *) create_limit_plan(context,
+											  root,
 											  (LimitPath *) best_path,
 											  flags);
 			break;
 		case T_GatherMerge:
-			plan = (Plan *) create_gather_merge_plan(root,
+			plan = (Plan *) create_gather_merge_plan(context,
+													 root,
 													 (GatherMergePath *) best_path);
 			break;
 		default:
@@ -545,16 +622,44 @@ create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
 			plan = NULL;		/* keep compiler quiet */
 			break;
 	}
+	plan_consider_jit(context, root, plan);
 
 	return plan;
 }
 
+static void
+plan_consider_jit(CreatePlanContext *context, PlannerInfo *root, Plan *plan)
+{
+	plan->jit = false;
+
+	 /* Determine which JIT options to enable for this plan node */
+	if (jit_enabled)
+	{
+		Cost	total_cost;
+
+		/*
+		 * Take into account the number of times that we expect to rescan a
+		 * given plan node.  For example, subplans being invoked under the
+		 * inside of a Nested Loop may be rescanned many times.  JITing these
+		 * may be more worthwhile.
+		 */
+		total_cost = plan->total_cost * plan->est_calls;
+
+		if (total_cost > jit_above_cost)
+		{
+			plan->jit = true;
+			context->jit = true;
+		}
+	}
+}
+
 /*
  * create_scan_plan
  *	 Create a scan plan for the parent relation of 'best_path'.
  */
 static Plan *
-create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
+create_scan_plan(CreatePlanContext *context, PlannerInfo *root, Path *best_path,
+				 int flags)
 {
 	RelOptInfo *rel = best_path->parent;
 	List	   *scan_clauses;
@@ -675,21 +780,24 @@ create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
 	switch (best_path->pathtype)
 	{
 		case T_SeqScan:
-			plan = (Plan *) create_seqscan_plan(root,
+			plan = (Plan *) create_seqscan_plan(context,
+												root,
 												best_path,
 												tlist,
 												scan_clauses);
 			break;
 
 		case T_SampleScan:
-			plan = (Plan *) create_samplescan_plan(root,
+			plan = (Plan *) create_samplescan_plan(context,
+												   root,
 												   best_path,
 												   tlist,
 												   scan_clauses);
 			break;
 
 		case T_IndexScan:
-			plan = (Plan *) create_indexscan_plan(root,
+			plan = (Plan *) create_indexscan_plan(context,
+												  root,
 												  (IndexPath *) best_path,
 												  tlist,
 												  scan_clauses,
@@ -697,7 +805,8 @@ create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
 			break;
 
 		case T_IndexOnlyScan:
-			plan = (Plan *) create_indexscan_plan(root,
+			plan = (Plan *) create_indexscan_plan(context,
+												  root,
 												  (IndexPath *) best_path,
 												  tlist,
 												  scan_clauses,
@@ -705,91 +814,104 @@ create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
 			break;
 
 		case T_BitmapHeapScan:
-			plan = (Plan *) create_bitmap_scan_plan(root,
+			plan = (Plan *) create_bitmap_scan_plan(context,
+													root,
 													(BitmapHeapPath *) best_path,
 													tlist,
 													scan_clauses);
 			break;
 
 		case T_TidScan:
-			plan = (Plan *) create_tidscan_plan(root,
+			plan = (Plan *) create_tidscan_plan(context,
+												root,
 												(TidPath *) best_path,
 												tlist,
 												scan_clauses);
 			break;
 
 		case T_TidRangeScan:
-			plan = (Plan *) create_tidrangescan_plan(root,
+			plan = (Plan *) create_tidrangescan_plan(context,
+													 root,
 													 (TidRangePath *) best_path,
 													 tlist,
 													 scan_clauses);
 			break;
 
 		case T_SubqueryScan:
-			plan = (Plan *) create_subqueryscan_plan(root,
+			plan = (Plan *) create_subqueryscan_plan(context,
+													 root,
 													 (SubqueryScanPath *) best_path,
 													 tlist,
 													 scan_clauses);
 			break;
 
 		case T_FunctionScan:
-			plan = (Plan *) create_functionscan_plan(root,
+			plan = (Plan *) create_functionscan_plan(context,
+													 root,
 													 best_path,
 													 tlist,
 													 scan_clauses);
 			break;
 
 		case T_TableFuncScan:
-			plan = (Plan *) create_tablefuncscan_plan(root,
+			plan = (Plan *) create_tablefuncscan_plan(context,
+													  root,
 													  best_path,
 													  tlist,
 													  scan_clauses);
 			break;
 
 		case T_ValuesScan:
-			plan = (Plan *) create_valuesscan_plan(root,
+			plan = (Plan *) create_valuesscan_plan(context,
+												   root,
 												   best_path,
 												   tlist,
 												   scan_clauses);
 			break;
 
 		case T_CteScan:
-			plan = (Plan *) create_ctescan_plan(root,
+			plan = (Plan *) create_ctescan_plan(context,
+												root,
 												best_path,
 												tlist,
 												scan_clauses);
 			break;
 
 		case T_NamedTuplestoreScan:
-			plan = (Plan *) create_namedtuplestorescan_plan(root,
+			plan = (Plan *) create_namedtuplestorescan_plan(context,
+															root,
 															best_path,
 															tlist,
 															scan_clauses);
 			break;
 
 		case T_Result:
-			plan = (Plan *) create_resultscan_plan(root,
+			plan = (Plan *) create_resultscan_plan(context,
+												   root,
 												   best_path,
 												   tlist,
 												   scan_clauses);
 			break;
 
 		case T_WorkTableScan:
-			plan = (Plan *) create_worktablescan_plan(root,
+			plan = (Plan *) create_worktablescan_plan(context,
+													  root,
 													  best_path,
 													  tlist,
 													  scan_clauses);
 			break;
 
 		case T_ForeignScan:
-			plan = (Plan *) create_foreignscan_plan(root,
+			plan = (Plan *) create_foreignscan_plan(context,
+													root,
 													(ForeignPath *) best_path,
 													tlist,
 													scan_clauses);
 			break;
 
 		case T_CustomScan:
-			plan = (Plan *) create_customscan_plan(root,
+			plan = (Plan *) create_customscan_plan(context,
+												   root,
 												   (CustomPath *) best_path,
 												   tlist,
 												   scan_clauses);
@@ -808,7 +930,7 @@ create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
 	 * quals.
 	 */
 	if (gating_clauses)
-		plan = create_gating_plan(root, best_path, plan, gating_clauses);
+		plan = create_gating_plan(context, root, best_path, plan, gating_clauses);
 
 	return plan;
 }
@@ -1017,8 +1139,8 @@ get_gating_quals(PlannerInfo *root, List *quals)
  * Add a gating Result node atop the already-built plan.
  */
 static Plan *
-create_gating_plan(PlannerInfo *root, Path *path, Plan *plan,
-				   List *gating_quals)
+create_gating_plan(CreatePlanContext *context, PlannerInfo *root, Path *path,
+				   Plan *plan, List *gating_quals)
 {
 	Plan	   *gplan;
 	Plan	   *splan;
@@ -1063,6 +1185,7 @@ create_gating_plan(PlannerInfo *root, Path *path, Plan *plan,
 	 * gating qual being true.
 	 */
 	copy_plan_costsize(gplan, plan);
+	gplan->est_calls = clamp_row_est(context->est_calls);
 
 	/* Gating quals could be unsafe, so better use the Path's safety flag */
 	gplan->parallel_safe = path->parallel_safe;
@@ -1076,7 +1199,7 @@ create_gating_plan(PlannerInfo *root, Path *path, Plan *plan,
  *	  inner and outer paths.
  */
 static Plan *
-create_join_plan(PlannerInfo *root, JoinPath *best_path)
+create_join_plan(CreatePlanContext *context, PlannerInfo *root, JoinPath *best_path)
 {
 	Plan	   *plan;
 	List	   *gating_clauses;
@@ -1084,15 +1207,18 @@ create_join_plan(PlannerInfo *root, JoinPath *best_path)
 	switch (best_path->path.pathtype)
 	{
 		case T_MergeJoin:
-			plan = (Plan *) create_mergejoin_plan(root,
+			plan = (Plan *) create_mergejoin_plan(context,
+												  root,
 												  (MergePath *) best_path);
 			break;
 		case T_HashJoin:
-			plan = (Plan *) create_hashjoin_plan(root,
+			plan = (Plan *) create_hashjoin_plan(context,
+												 root,
 												 (HashPath *) best_path);
 			break;
 		case T_NestLoop:
-			plan = (Plan *) create_nestloop_plan(root,
+			plan = (Plan *) create_nestloop_plan(context,
+												 root,
 												 (NestPath *) best_path);
 			break;
 		default:
@@ -1109,7 +1235,7 @@ create_join_plan(PlannerInfo *root, JoinPath *best_path)
 	 */
 	gating_clauses = get_gating_quals(root, best_path->joinrestrictinfo);
 	if (gating_clauses)
-		plan = create_gating_plan(root, (Path *) best_path, plan,
+		plan = create_gating_plan(context, root, (Path *) best_path, plan,
 								  gating_clauses);
 
 #ifdef NOT_USED
@@ -1125,6 +1251,8 @@ create_join_plan(PlannerInfo *root, JoinPath *best_path)
 							   get_actual_clauses(get_loc_restrictinfo(best_path))));
 #endif
 
+	plan->est_calls = clamp_row_est(context->est_calls);
+
 	return plan;
 }
 
@@ -1211,7 +1339,8 @@ mark_async_capable_plan(Plan *plan, Path *path)
  *	  Returns a Plan node.
  */
 static Plan *
-create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
+create_append_plan(CreatePlanContext *context, PlannerInfo *root,
+				   AppendPath *best_path, int flags)
 {
 	Append	   *plan;
 	List	   *tlist = build_path_tlist(root, &best_path->path);
@@ -1280,7 +1409,8 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
 		 * function result; it must be the same plan node.  However, we then
 		 * need to detect whether any tlist entries were added.
 		 */
-		(void) prepare_sort_from_pathkeys((Plan *) plan, pathkeys,
+		(void) prepare_sort_from_pathkeys(context,
+										  (Plan *) plan, pathkeys,
 										  best_path->path.parent->relids,
 										  NULL,
 										  true,
@@ -1304,7 +1434,7 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
 		Plan	   *subplan;
 
 		/* Must insist that all children return the same tlist */
-		subplan = create_plan_recurse(root, subpath, CP_EXACT_TLIST);
+		subplan = create_plan_recurse(context, root, subpath, CP_EXACT_TLIST);
 
 		/*
 		 * For ordered Appends, we must insert a Sort node if subplan isn't
@@ -1324,7 +1454,8 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
 			 * don't need an explicit sort, to make sure they are returning
 			 * the same sort key columns the Append expects.
 			 */
-			subplan = prepare_sort_from_pathkeys(subplan, pathkeys,
+			subplan = prepare_sort_from_pathkeys(context,
+												 subplan, pathkeys,
 												 subpath->parent->relids,
 												 nodeSortColIdx,
 												 false,
@@ -1408,6 +1539,7 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
 	plan->part_prune_info = partpruneinfo;
 
 	copy_generic_path_info(&plan->plan, (Path *) best_path);
+	plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	/*
 	 * If prepare_sort_from_pathkeys added sort columns, but we were told to
@@ -1417,7 +1549,7 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
 	if (tlist_was_changed && (flags & (CP_EXACT_TLIST | CP_SMALL_TLIST)))
 	{
 		tlist = list_copy_head(plan->plan.targetlist, orig_tlist_length);
-		return inject_projection_plan((Plan *) plan, tlist,
+		return inject_projection_plan(context, (Plan *) plan, tlist,
 									  plan->plan.parallel_safe);
 	}
 	else
@@ -1432,8 +1564,8 @@ create_append_plan(PlannerInfo *root, AppendPath *best_path, int flags)
  *	  Returns a Plan node.
  */
 static Plan *
-create_merge_append_plan(PlannerInfo *root, MergeAppendPath *best_path,
-						 int flags)
+create_merge_append_plan(CreatePlanContext *context, PlannerInfo *root,
+						 MergeAppendPath *best_path, int flags)
 {
 	MergeAppend *node = makeNode(MergeAppend);
 	Plan	   *plan = &node->plan;
